<?

 /*****************************************************************************
 * Filename: api/csv/request.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 $_path["root"]="../../";
 require($_path["root"]."include.php");

 if($_session->inBackend()) //backend project
  $_session->frontend(); //switch to frontend project

 if($_config->get("benchmark"))
 {
  require_once($_path["include"]."benchmark.php");
  $_benchmark=new Benchmark();
 }

 require_once($_path["api"]."csv.php");

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
 <head>
  <title>JAS CSV interface tester</title>
  <style>
   body
   {
    font-size: 8pt;
    font-family: verdana;
   }
   ul
   {
    list-style-type: decimal;
    margin: 0px 0px 0px 50px;
    padding: 0px;
   }
   form textarea,
   form input
   {
    float: left;
    vertical-align: top;
   }
  </style>

  <script type="text/javascript">
   function setCSV(type)
   {
    var csv="";
    switch(type)
    {
     case "language":
     {
      csv="language;modules;nl";
      break;
     }
     case "modules":
     {
      csv="modules;all";
      break;
     }
     case "module":
     {
      csv="modules\ncategories";
      break;
     }
     case "data":
     {
      csv="data;categories;view;all;api;;true\nname;updated\n;\nsort;updated-;nr-;\nmutilation;name;strip;15";
      break;
     }
     default: 
     {
      csv=type;
      break;
     }
    }

    document.getElementById("request").innerHTML=csv;
   }
  </script>
 </head>

 <body>
 <form action="request.php">
  <textarea name="request" id="request" style="width: 600px; height: 400px;"><?=(isset($_REQUEST["request"])?$_REQUEST["request"]:"")?></textarea>
  <input type="submit" value="Language" onclick="setCSV('language')" />
  <input type="submit" value="Projects" onclick="setCSV('projects')" />
  <input type="submit" value="Modules" onclick="setCSV('modules')" />
  <input type="submit" value="Module" onclick="setCSV('module')" />
  <input type="submit" value="Data" onclick="setCSV('data')" />
  <br/><br/><input type="submit" value="Submit"/>
 </form>
 <br style="clear: both;" />
 <?

 if($_benchmark) $_benchmark->start("API_CSV");
 $api=new API_CSV("server");

 if($_benchmark) $_benchmark->start("Parse");
 $ret=$api->parse((isset($_REQUEST["request"])?$_REQUEST["request"]:""));
 if($_benchmark) $_benchmark->stop();
 if(!$ret)
 {
  if($_benchmark) $_benchmark->start("Error");
  $api->error();
  if($_benchmark) $_benchmark->stop();
 }
 else
 {
  if($_benchmark) $_benchmark->start("Commands");
  $ret=$api->commands();
  if($_benchmark) $_benchmark->stop();
  if(!$ret)
  {
   if($_benchmark) $_benchmark->start("Error");
   $api->error();
   if($_benchmark) $_benchmark->stop();
  }
  else
  {
   if($_benchmark) $_benchmark->start("Format");
   $ret=$api->format();
   if($_benchmark) $_benchmark->stop();
   if(!$ret)
   {
    if($_benchmark) $_benchmark->start("Error");
    $api->error();
    if($_benchmark) $_benchmark->stop();
   }
  }
 }


 if($_benchmark) $_benchmark->start("Output");
 print "<pre>".$api->output(false)."</pre>";
 if($_benchmark) $_benchmark->stop();
 
 if($_benchmark) $_benchmark->stop();
 if($_benchmark) print "<br/>".$_benchmark->show();

 ?>
 </body>
</html>
