<?

 /*****************************************************************************
 * Filename: include/modules/configRepositories.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class System_Module_configRepositories extends Module
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   $this->data->title="Repositories configuration";

   $this->data->defaultFields("id;added;updated");
   $this->data->setShowFields(); //clear show fields

   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 256); //view rights for all

   $this->data->addField("code", "title", "all", false, 3, 5, "JAS", "Code");
   $this->data->addField("name", "title", "all", "title", 5, 50, "JAS repository", "Name");

   $this->data->addField("url", "url", "all", "", 5, 255, "http://jas.junerules.com/", "Repository URL");
   $this->data->addField("apiurl", "url", "show", "", 5, 255, "api://jas.junerules.com/", "API URL");
   $this->data->addField("apitype", "list", "all", "", 1, 4, "Data", "API type");
   $this->data->listOptions("apitype", "CSV", "Data", "XML");
   $this->data->addField("content", "multilist", "all", "", 1, 65535, Array("Releases", "Plugins"), "Content");
   $this->data->listOptions("content", "Releases", "Plugins");

   $this->data->addUnique("code", "code");
  }

  function viewPreGet()
  {
   if($this->data->check("use", "show", "apiurl")) //apiurl is show field
   {
    if(!$this->data->check("use", "show", "url"))
     $this->data->field["url"]["use"].=";show";
    if(!$this->data->check("use", "show", "apitype"))
     $this->data->field["apitype"]["use"].=";show";
   }

   return true;
  }

  function viewPostGet()
  {
   if($this->data->check("use", "show", "apiurl"))
   {
    for($c=0;$c<$this->data->vmax;$c++)
    {
     if(preg_match("!^([a-z0-9]+)://(.+)$!i", $this->data->getValue("url", $c), $m))
     {
      $url="api://".$m[2];

      if($m[1]=="https")
       $url.=(strpos($url, "?")?"&":"?")."secure";

      if($this->data->getValue("apitype", $c)!="Data")
       $url.=(strpos($url, "?")?"&":"?")."type=".$this->data->getValue("apitype", $c);

      $this->data->setValue("apiurl", $url, $c);
     }
    }
   }

   return true;
  }
 }

?>
