<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/system.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/core.php");

 class UT_System extends UT_Core
 {
  function Path()
  {
   global $_path;

   $status=UT_OK;
   foreach($_path as $key => $file)
   {
    if($key=="project"||$key="root") //don't check projects paths and root
     continue;

    else if(!file_exists($_path["root"].$file))
    {
     $this->e->add("Directory: \"".$file."\" doesn't exist", "error");
     $status=UT_FAILED;
    }
   }

   return $status;
  }

  function FileStructure()
  {
   global $_path;

   $files=Array(
    "index.php",
    "include.php",
    "include/browser.php",
    "include/cms.php",
    "include/config.php",
    "include/data.base.php",
    "include/data.php",
    "include/db.conf.php",
    "include/errors.php",
    "include/form.php",
    "include/functions.php",
    "include/language.php",
    "include/layout.php",
    "include/module.php",
    "include/php.ini.php",
    "include/plugin.php",
    "include/session.php",
    "include/format/format.php",
    "include/format/csv.php",
    "include/format/template.php",
    "include/format/xml.php",
    "include/protocol/protocol.php",
    "include/protocol/http.php",
    "include/modules/categories.php",
    "include/modules/comments.php",
    "include/modules/config.php",
    "include/modules/empty.php",
    "include/modules/files.php",
    "include/modules/groupRights.php",
    "include/modules/images.php",
    "include/modules/log.php",
    "include/modules/notes.php",
    "include/modules/pluginConfigs.php",
    "include/modules/pluginInfo.php",
    "include/modules/userRights.php",
    "include/modules/users.php",
   );

   $status=UT_OK;
   foreach($files as $file)
   {
    if(!file_exists($_path["root"].$file))
    {
     $this->e->add("File: \"".$file."\" doesn't exist", "error");
     $status=UT_FAILED;
    }
   }

   return $status;
  }

  function htaccessFiles()
  {
   global $_path;

   $files=Array(
    $_path["include"].".htaccess", 
    $_path["plugins"]."unit_testing/images/.htaccess", 
    $_path["project"]["include"].".htaccess", 
   );

   if(is_dir($_path["project"]["cache"]))
    $files[]=$_path["project"]["cache"].".htaccess";

   $status=UT_OK;
   foreach($files as $file)
   {
    if(!file_exists($file))
    {
     $this->e->add(".htaccess file: \"".$file."\" doesn't exist", "error");
     $status=UT_FAILED;
    }
   }

   return $status;
  }
 }

?>
