<?

 /*****************************************************************************
 * Filename: include/rewrite.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."fs.php");

 //detect if mod rewrite is active
 if($_session->get("modRewriteActive")===NULL)
 {
  if(isset($_SERVER["REDIRECT_URL"]))
   $_session->set("modRewriteActive", true);
  else if(function_exists("apache_get_modules")&&in_array("mod_rewrite", apache_get_modules())) //mod_rewrite loaded
   $_session->set("modRewriteActive", FS::grepS("/RewriteEngine\s+on/i", $_path["root"].".htaccess")); //can still be deactivated or .htaccess is ignored in global apache config
  else
   $_session->set("modRewriteActive", false);
 }


 if(isset($_config)&&$_config->get("useModRewrite")&&$_path["HTML"]["relative"]===false)
 {
  $relativePath=$_path["HTML"]["url"];

  if(strlen($_path["HTML"]["current"])>1) //get relative path
   $relativePath=preg_replace("!".preg_quote($_path["HTML"]["current"], "!")."!", "", $relativePath, 1); //strip root path

  if($relativePath)
  {
   if(strlen($relativePath)==1&&$relativePath[0]=="/") // "/"
    $relativePath=""; //root
   else if($relativePath[0]=="/") //leading "/"
    $relativePath=preg_replace("!^/(.+/)[^/]*$!", "\\1", $relativePath); //remove leading "/" and script file
   else
    $relativePath=preg_replace("![^/]*$!", "\\1", $relativePath); //remove script file
  }

  $_path["HTML"]["relative"]=$relativePath;
  $_path["HTML"]["prefix"]=str_repeat("../", substr_count($relativePath, "/"));

  unset($relativePath);
 }
?>
